package com.eladit.hb9eik.blueduo;

import java.io.IOException;
import java.io.OutputStream;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.Canvas;
import android.graphics.Path;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Rect;
import android.os.Handler;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;
import android.graphics.Matrix;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

//This class was implemented by Ankit Srivastava. Please consider acknowledging the author if it ends up being useful to you.

public class plot2d extends View implements OnTouchListener {

	private Paint paint;

	private Matrix matrix;
	public Bitmap  mBitmap;
	private float[] xvalues,yvalues;
	public float maxx,maxy,minx,miny,minyz,maxyz;
	public int dx,watrfalactive;
	public float canvasHeight;
	public float canvasWidth;
	public float marginy,marginx;
	private static final int THR_COLOR_LENGTH =17;
	float Thr_R_color[] = {   0.0f,   0.0f,   0.0f, 255.0f, 255.0f };
	float Thr_G_color[] = {   0.0f,   0.0f,   0.0f, 255.0f, 255.0f };
	float Thr_B_color[] = {   0.0f,   0.0f, 255.0f, 255.0f, 255.0f };
	private char r_val,g_val,b_val;
	private static final int WIDTH = 1024;
	private static final int HEIGHT = 500;
	private static final int STRIDE = 855;
	private int[] colors;
	private int[] colors2;
	private String fr="";
	private MainActivity app;
	private int expanding=0;
	private int preExp=0;
	private int postExp=0;
	private int valmed;
	public int screenWidth;

	private int vectorLength;
	private int axes = 1;
	private float m_downXValue=0,m_downYValue=0;
	public int x_mk=0;

	private OutputStream outS;
	private long tuningFrequency;
	private long ritFrequency;
	private int pitch, pitchPos, pitchIndex;

	public plot2d(Context context, float[] xvalues, float[] yvalues, int axes, int height, int width) {
		super(context);
		marginy=height/80;
		marginx=width/25;
		canvasHeight = height/2 - 2*marginy;
		canvasWidth = width - (int)(2.3*marginx);
		colors=new int[STRIDE * (int)canvasHeight];
		colors2=new int[STRIDE * (int)canvasHeight];
		this.xvalues=xvalues;
		this.yvalues=yvalues;
		this.axes=axes;
		vectorLength = xvalues.length;
		paint = new Paint();
	}

	public void setApp( MainActivity app ) {
		this.app=app;
	}

	public void putTuningFrequency( long frequency ) {
		tuningFrequency=frequency;
	}
	public void putRit( long frequency ) {
		ritFrequency=frequency;
		tuningFrequency -= frequency;
	}
	public void putPitch( int frequency, boolean cwplus, boolean cwminus ) {
		if( cwplus ) {
			pitch = -frequency;
		} else if( cwminus ) {
			pitch = +frequency;
		} else {
			pitch = 0;
		}
		pitchPos=Math.round(pitch*(maxx-minx)/160000);
		pitchIndex=Math.round(pitch*1024/STRIDE);
	}

@Override
    public boolean onTouch(View v, MotionEvent event) {
		int halfkilo;
		NumberFormat numberFormat = new DecimalFormat("###,###,###");
		switch (event.getAction()) {
			case MotionEvent.ACTION_MOVE:
				m_downXValue = event.getX();
				m_downYValue = event.getY();
				if(m_downXValue<2*marginx)m_downXValue = 2*marginx;
				if(m_downXValue>2*marginx+canvasWidth)m_downXValue = 2*marginx+canvasWidth;
				if(expanding==2) {
					halfkilo = (int) (tuningFrequency + (preExp+postExp)*10000-80000+((toValueInt(canvasWidth, minx, maxx, m_downXValue - 2 * marginx) - 512) * 192000 / 1024/4) + 50) / 100;
					fr=numberFormat.format(halfkilo*100)+" Hz";
				}else {
					halfkilo = (int) (tuningFrequency + ((toValueInt(canvasWidth, minx, maxx, m_downXValue - 2 * marginx) - 512) * 192000 / 1024) + 250) / 500;
					fr=numberFormat.format(halfkilo*500)+" Hz";
				}
				break;
	        case MotionEvent.ACTION_DOWN:
	            //store the X value when the user's finger was pressed down
				m_downXValue = event.getX();
				m_downYValue = event.getY();
				if(m_downYValue<=canvasHeight+marginy) {
					if(expanding==0) {
						expanding=1;
					} else {
						expanding=0;
					}
				}
				if(m_downXValue<2*marginx)m_downXValue = 2*marginx;
				if(m_downXValue>2*marginx+canvasWidth)m_downXValue = 2*marginx+canvasWidth;
	            break;
	        case MotionEvent.ACTION_UP:
				if(m_downYValue>canvasHeight+marginy) {
					if(expanding==2) {
						halfkilo = (int) (tuningFrequency + ritFrequency + (preExp+postExp)*10000-80000+((toValueInt(canvasWidth, minx, maxx, m_downXValue - 2 * marginx) - 512) * 192000 / 1024/4) + 50) / 100;
						app.setFreq(halfkilo*100,null,null);
						preExp=3;
						postExp=5;
					}else {
						halfkilo = (int) (tuningFrequency + ritFrequency + ((toValueInt(canvasWidth, minx, maxx, m_downXValue - 2 * marginx) - 512) * 192000 / 1024) + 250) / 500;
						app.setFreq(halfkilo*500,null,null);
					}
				}
				m_downXValue = 0;
				m_downYValue = 0;
				if(expanding==1) {
					int vm = (valmed-5)/10;
					minyz=vm*10-30;
					maxyz=vm*10+50;
					expanding=2;
				}
				fr="";
				break;
	    }
		//invalidate();
		return true;
    }

	@Override
	protected void onDraw(Canvas canvas) {
		int[] xvaluesInPixels = toPixel(canvasWidth, minx, maxx, xvalues);
		int[] yvaluesInPixels = toPixel(canvasHeight, miny, maxy, yvalues);
		int[] yvaluesInPixelsz = toPixel(canvasHeight, minyz, maxyz, yvalues);

		canvas.drawARGB(255, 0, 0, 0);
		paint.setStrokeWidth(1);
		for( int j=(int)0; j<=canvasHeight; j++ ){
			int blue=0xFF-400*j/(int)canvasHeight;
			if( blue<1 ){ blue=0;}
			paint.setARGB(0xFF, 0, 0, blue);
			canvas.drawLine(2*marginx,marginy+j,2*marginx+canvasWidth,marginy+j,paint);
		}
		//ASSE Y
		if (axes!=0) {
			String temp;
			paint.setColor(Color.WHITE);
			paint.setTextAlign(Paint.Align.RIGHT);
			paint.setTextSize(12*screenWidth/800);
			for (int j=0;j<dx;j++){
				if( expanding == 2 ){
					temp = Integer.toString((int) (minyz + j * (maxyz - minyz) / (dx - 1)));
				} else {
					temp = Integer.toString((int) (miny + j * (maxy - miny) / (dx - 1)));
				}
				canvas.drawText(temp,2*marginx-4,marginy+12*screenWidth/1600+canvasHeight-j*canvasHeight/(dx-1),paint);
			}
		}
		//Grafico
		float x1,x2,y1,y2;
		Path path = new Path();
		path.setFillType(Path.FillType.EVEN_ODD);
		path.moveTo(2*marginx,marginy+canvasHeight);
		for (int i = 0; i < vectorLength-1; i++) {
			int j=i+pitchPos;
			if( expanding==2 ){
				j+=(maxx-minx)*preExp/8;
			}
			x1=xvaluesInPixels[i];
			if( expanding==2 ){
				x1*=4;
			}
			x1+=2*marginx;
			if(x1>=2*marginx && x1<=2*marginx+canvasWidth) {
				paint.setColor(0xFF4444FF);
				if( expanding == 2 ) {
					y1 = marginy + canvasHeight - yvaluesInPixelsz[j] + 1;
				}else {
					y1 = marginy + canvasHeight - yvaluesInPixels[j] + 1;
				}
				if (y1 > (marginy + canvasHeight)) y1 = marginy + canvasHeight;
				if (y1 < marginy) y1 = marginy;
				path.lineTo(x1,y1);
			}
		}
		path.lineTo(2*marginx+canvasWidth,marginy+canvasHeight);
		path.close();
		canvas.drawPath(path, paint);
		paint.setColor(Color.argb(255, 0x85, 0x85, 0x85));
		for(int j = 0;j<dx;j++) {
			//assi orizzontali:
			canvas.drawLine(2*marginx,marginy+canvasHeight-j*canvasHeight/(dx-1),2*marginx+canvasWidth,marginy+canvasHeight-j*canvasHeight/(dx-1),paint);
		}
		int prec=0;
		for(int j = 0;j<dx;j++) {
			paint.setColor(Color.argb(255, 0x85, 0x85, 0x85));
			//assi verticali:
			if( expanding==1 && prec==0 && 2*marginx+j*canvasWidth/(dx-1)>=m_downXValue ){
				prec=1;
				preExp=postExp=j;
			}
			if( j==(dx-1)/2 && expanding != 2 ){
				paint.setColor(Color.WHITE);
			}
			canvas.drawLine(2*marginx+j*canvasWidth/(dx-1),marginy,2*marginx+j*canvasWidth/(dx-1),marginy+canvasHeight,paint);
			if( expanding==2 ) {
				if( j%2==1 ){
					paint.setColor(Color.WHITE);
					paint.setTextAlign(Paint.Align.CENTER);
					paint.setTextSize(12*screenWidth/800);
					canvas.drawText(Integer.toString((j - 4) * 5) + "kHz", 2 * marginx + j * canvasWidth / (dx - 1), marginy + canvasHeight - 5, paint);
				}
			} else {
				if( j%2==1 ) {
					paint.setColor(Color.WHITE);
					paint.setTextAlign(Paint.Align.CENTER);
					paint.setTextSize(12*screenWidth/800);
					canvas.drawText(Integer.toString((j - 4) * 20) + "kHz", 2 * marginx + j * canvasWidth / (dx - 1), marginy + canvasHeight - 5, paint);
				}
			}
		}
		if( ritFrequency!=0 ){
			paint.setColor(Color.RED);
			if( expanding==2 ) {
				if( ritFrequency > ( preExp - 4) * 20000 && ritFrequency < ( postExp - 4) * 20000 ) {
					float diff = ritFrequency - (preExp-3) *20000;
					canvas.drawLine((float) (2 * marginx + canvasWidth / 2 + canvasWidth * diff / 40000), marginy, (float) (2 * marginx + canvasWidth / 2 + canvasWidth * diff / 40000 ), marginy + canvasHeight, paint);
				}
			} else {
				canvas.drawLine( (float) ( 2 * marginx + canvasWidth/2 + canvasWidth * ritFrequency / 160000 ), marginy, (float ) ( 2 * marginx + canvasWidth/2 + canvasWidth * ritFrequency / 160000 ), marginy + canvasHeight, paint);
			}
		}
		if( expanding==1 ) {
			if( --preExp<0 ) {
				preExp=0;
				postExp=2;
			} else if( ++postExp>=dx-1 ){
				preExp=dx-3;
				postExp=dx-1;
			}
		}
		if( expanding==2 ) {
			NumberFormat numberFormat = new DecimalFormat("###,###,###");
			paint.setColor(Color.WHITE);
			paint.setTextAlign(Paint.Align.CENTER);
			paint.setTextSize(12*screenWidth/800);
			canvas.drawText(numberFormat.format(tuningFrequency+((preExp+postExp)/2 - 4) * 20000) + " Hz", 2 * marginx + canvasWidth / 2, marginy + canvasHeight - 5, paint);
		}

		//Grafico
		for (int i = 0; i < vectorLength-1; i++) {
			int j=i+pitchPos;
			if( expanding==2 ){
				j+=(maxx-minx)*preExp/8;
			}
			x1=xvaluesInPixels[i];
			x2=xvaluesInPixels[i+1];
			if( expanding==2 ){
				x1*=4;
				x2*=4;
			}
			x1+=2*marginx;
			x2+=2*marginx;
			if(x1>2*marginx+1 && x2<=2*marginx+canvasWidth) {
				paint.setStrokeWidth(2);
				paint.setColor(Color.WHITE);
				if( expanding == 2 ) {
					y1 = marginy + canvasHeight - yvaluesInPixelsz[j];
				}else {
					y1 = marginy + canvasHeight - yvaluesInPixels[j];
				}
				if (y1 > (marginy + canvasHeight)) y1 = marginy + canvasHeight;
				if (y1 < marginy) y1 = marginy;
				if( expanding == 2 ) {
					y2 = marginy + canvasHeight - yvaluesInPixelsz[j+1];
				}else {
					y2 = marginy + canvasHeight - yvaluesInPixels[j+1];
				}
				if (y2 > (marginy + canvasHeight)) y2 = marginy + canvasHeight;
				if (y2 < marginy) y2 = marginy;
				canvas.drawLine(x1, y1, x2, y2, paint);
				paint.setStrokeWidth(1);
			}
		}
		if( expanding==2) {
			createColors(yvalues, preExp*80000+pitch*4, 4);
		} else {
			createColors(yvalues, pitch, 1);
		}
		final Bitmap bmp1 = Bitmap.createBitmap(colors, 0, STRIDE, STRIDE, (int)canvasHeight,Bitmap.Config.ARGB_8888);
		// bmp1.setHasAlpha(false);
		Rect where = new Rect((int)(2*marginx),(int)(marginy+canvasHeight+2),(int)(2*marginx+canvasWidth),(int)(marginy+2*canvasHeight+2));
		canvas.drawBitmap(bmp1, null, where, paint);

		if( expanding != 1 ) {
			if (m_downXValue > 0) {
				if (m_downYValue <= canvasHeight + marginy) {
					paint.setColor(Color.GREEN);
				} else {
					paint.setColor(Color.RED);
				}
				x_mk = (int) toValueInt(canvasWidth, minx, maxx, m_downXValue - 2 * marginx);
				canvas.drawLine(m_downXValue, marginy, m_downXValue, marginy + canvasHeight, paint);
				canvas.drawLine(m_downXValue, marginy + canvasHeight, m_downXValue, marginy + 2 * canvasHeight, paint);
			}
			paint.setColor(Color.YELLOW);
			if (m_downXValue < canvasWidth / 2 + 2 * marginx) {
				paint.setTextAlign(Paint.Align.LEFT);
			} else {
				paint.setTextAlign(Paint.Align.RIGHT);
			}
			paint.setTextSize(18*screenWidth/800);
			canvas.drawText(fr, m_downXValue, marginy+18*screenWidth/800, paint);
		}
		if(expanding==1){
			paint.setColor(Color.YELLOW);
			canvas.drawLine(2*marginx+preExp*canvasWidth/(dx-1),marginy+2*canvasHeight,2*marginx+postExp*canvasWidth/(dx-1),marginy+2*canvasHeight,paint);
			canvas.drawLine(2*marginx+preExp*canvasWidth/(dx-1),marginy,2*marginx+postExp*canvasWidth/(dx-1),marginy,paint);
			canvas.drawLine(2*marginx+preExp*canvasWidth/(dx-1),marginy,2*marginx+preExp*canvasWidth/(dx-1),marginy+2*canvasHeight,paint);
			canvas.drawLine(2*marginx+postExp*canvasWidth/(dx-1),marginy,2*marginx+postExp*canvasWidth/(dx-1),marginy+2*canvasHeight,paint);
		}
		if(expanding==2){
			paint.setColor(Color.YELLOW);
			canvas.drawLine(2*marginx,marginy+2*canvasHeight,2*marginx+canvasWidth,marginy+2*canvasHeight,paint);
			canvas.drawLine(2*marginx,marginy,2*marginx+canvasWidth,marginy,paint);
			canvas.drawLine(2*marginx,marginy,2*marginx,marginy+2*canvasHeight,paint);
			canvas.drawLine(2*marginx+canvasWidth,marginy,2*marginx+canvasWidth,marginy+2*canvasHeight,paint);
			paint.setTextAlign(Paint.Align.LEFT);
			paint.setTextSize(20*screenWidth/800);
			canvas.drawText("ZOOM", 2*marginx+5, marginy+2*canvasHeight-5, paint);
		}
	}

	private int[] toPixel(float pixels, float min, float max, float[] value) {
		double[] p = new double[value.length];
		int[] pint = new int[value.length];
		for (int i = 0; i < value.length; i++) {
			p[i] = ((value[i]-min)/(max-min))*pixels;
			pint[i] = (int)p[i];
		}
		return (pint);
	}

	private float toValueInt(float pixels, float min, float max, float pix) {
		float p=0;
		if(pix>=pixels)pix=pixels-1;
		p=pix*(max-minx)/pixels+minx;
		return p;
	}

	public void NewData( float[] xvalues, float[] yvalues) {
		this.xvalues=xvalues;
		this.yvalues=yvalues;
		vectorLength = xvalues.length;
		minx=85;
		maxx=939;
		invalidate();
	}

	private void ConvertMeasColor(float menval,int valm) {
		float m = 0;
		float dx = 0;
		float delta_x = 0;
		int idx=0;
		float val = menval;
		int j;

		if( val > valm+15 ) {
			j=3;
			dx=delta_x=1;
		} else if ( val > valm+5 ) {
			j=2;
			dx=val-valm-5;
			delta_x=10;
		} else if( val> valm-5) {
			j=1;
			dx=val-valm+5;
			delta_x=10;
		} else {
			j=0;
			dx=val+140;
			delta_x=valm+130;
		}
		m = (Thr_R_color[j+1] - Thr_R_color[j]) / delta_x;
		r_val = (char)(m * dx + Thr_R_color[j]);
		m = (Thr_G_color[j+1] - (float)Thr_G_color[j]) / delta_x;
		g_val = (char)(m * dx + Thr_G_color[j]);
		m = (Thr_B_color[j+1] - Thr_B_color[j]) / delta_x;
		b_val = (char)(m * dx + Thr_B_color[j]);
	}

	private void createColors( float[] ydata, int from, int zoom ) {
		System.arraycopy( colors, 0, colors2, STRIDE, colors.length - STRIDE  );
		colors = colors2.clone();
		int valmed=0;
		/*
		for (int x = 0; x < STRIDE; x++) {
			valmed+=ydata[x+85];
		}
		*/
		for (int x = 0; x < STRIDE/zoom; x++) {
			int z = x;
			if (zoom > 1) {
				z = x + Math.round(STRIDE * from / zoom / 160000);
			} else {
				z=x+Math.round(STRIDE*from/160000);
			}
			float val = ydata[z + 85];
			valmed += val;
		}
		valmed/=STRIDE/zoom;
		for (int x = 0; x < STRIDE/zoom; x++) {
			int z = x;
			if( zoom > 1 ){
				z=x+Math.round(STRIDE*from/zoom/160000);
			} else {
				z=x+Math.round(STRIDE*from/160000);
			}
			float val=ydata[z+85];
			ConvertMeasColor(val,valmed);
			int a_val = 0xFF;
			if( zoom == 1 ) {
				colors[x] = (a_val << 24) | (r_val << 16) | (g_val << 8) | b_val;
			} else {
				for( int l=0; l<zoom; l++) {
					if( x*zoom+l < STRIDE ) {
						colors[x * zoom + l] = (a_val << 24) | (r_val << 16) | (g_val << 8) | b_val;
					}
				}
			}
		}
		this.valmed=valmed;
	}

	public void AlertBox( String title, String message ){
		new AlertDialog.Builder(this.getContext())
				.setTitle( title )
				.setMessage( message + "\nPress OK to exit." )
				.setPositiveButton("OK", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface arg0, int arg1) { }
				}).show();
	}

}
